/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: BufferedImage.h
 * Description: BufferedImage class definition.
 *     BufferedImage is an image representation.
 * =============================================
 */

#ifndef _BUFFERED_IMAGE_
#define _BUFFERED_IMAGE_

#include <includes.h>

class BufferedImage {

    public:
        BufferedImage();
        BufferedImage(int Width, int Height, int BPP);
        ~BufferedImage();
        
        void drawImage(Surface screen);
        void setRGB(int x, int y, uint32_t pixel);
        void saveBMP(char * filename);
        
        uint32_t getRGB(int x, int y);
        
    private:
        int width;
        int height;
        int bpp;

        Surface image;
        void init();
};

#endif
