/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Video.h
 * Description: Video class definition. (SDL)
 * =============================================
 */

#ifndef _VIDEO_
#define _VIDEO_

#include <SDL.h>

typedef struct {
    SDL_Surface * s;
} Surface;

class Video {

    public:
        static void initVideo(int width, int height, int bpp);
        static void refreshVideo();
        static void delayVideo(int delay);
        static void finishVideo();
        static bool quitEvent();
        static void waitQuit();
        static uint32_t toRGB(uint8_t r, uint8_t g, uint8_t b);
};

#endif