/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: RayShooter.h
 * Description: RayShooter class definition.
 *     RayShooter generates rays from the
 *     camera.
 * =============================================
 */

#ifndef _RAY_SHOOTER_
#define _RAY_SHOOTER_

class Dimension {
    public:
        Dimension();
        Dimension(int Width, int Height);

        int width;
        int height;
};

#include <geometry/Util.h>
#include <geometry/Vector3D.h>
#include <objects/Camera.h>
#include <engine/Ray.h>

class RayShooter {

    public:
        RayShooter(Camera * Camera, Dimension image);
        ~RayShooter();
        Ray getRay(float x, float y);
    
    private:
        Vector3D * xdir; //x-direction on the projection plane
        Vector3D * ydir; //y-direction on the projection plane
        Vector3D * fray; //the first ray    
        Point3D eye; //Camera eye position

#if defined(GAALOP) || defined(VERSOR)
        Camera * camera;
#endif
};

#endif
