/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Point3D.cpp
 * Description: Point3D methods.
 * =============================================
 */

#include <geometry/Point3D.h>
#include <stdexcept>

Point3D::Point3D() {
    x = 0.0f;
    y = 0.0f;
    z = 0.0f;
}

Point3D::~Point3D() {
}

Point3D::Point3D(float X, float Y, float Z) {
    x = X;
    y = Y;
    z = Z;
}

float Point3D::getX() const { return x; }
float Point3D::getY() const { return y; }
float Point3D::getZ() const { return z; }

void Point3D::setX(float X) { x = X; }
void Point3D::setY(float Y) { y = Y; }
void Point3D::setZ(float Z) { z = Z; }

float& Point3D::operator[] (const int i)
{
    switch (i) {
        case 0: return x;
        case 1: return y;
        case 2: return z;
        default: throw std::invalid_argument("Index out of bounds.");
    }
}

float const& Point3D::operator[] (const int i) const
{
    switch (i) {
        case 0: return x;
        case 1: return y;
        case 2: return z;
        default: throw std::invalid_argument("Index out of bounds.");
    }
}
