/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Point3D.h
 * Description: Point3D class definition.
 *     Point3D is a 3 dimensional point
 *     representation.
 * =============================================
 */

#ifndef _POINT3D_
#define _POINT3D_

class Point3D {

    public:
        Point3D();
        Point3D(float X, float Y, float Z);
        virtual ~Point3D();

        float getX() const;
        float getY() const;
        float getZ() const;

        void setX(float X);
        void setY(float Y);
        void setZ(float Z);

        float& operator[] (const int i);
        float const& operator[] (const int i) const;
    protected:
        float x;
        float y;
        float z;
};

#endif
