/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Util.h
 * Description: Util class definition.
 *     Util has some methods for vector and
 *     color calculations.
 * =============================================
 */

#ifndef _UTIL_
#define _UTIL_

#include <geometry/Vector3D.h>
#include <objects/Color.h>

#define UTIL_GAMMA 1.1f

class Util {

    public:
        static float scalar_product(Vector3D a, Vector3D b);
        static Vector3D * cross_product(Vector3D a, Vector3D b);
        static Color gammacorrect(Color color);

};

#endif
