/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Vector3D.h
 * Description: Vector3D class definition.
 *     Vector3D is a 3 dimensional vector
 *     representation.
 * =============================================
 */

#ifndef _VECTOR3D_
#define _VECTOR3D_

#include <geometry/Point3D.h>

class Vector3D : public Point3D {

    public:
        Vector3D();
        Vector3D(float X, float Y, float Z);
        Vector3D(Point3D a, Point3D b);
        virtual ~Vector3D();

        void normalize();
        void multiply(float scalar);
        float norm();
        void sum(Vector3D a);
};

#endif
