/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: globais.cpp
 * Description: Global functions.
 * =============================================
 */

#include <includes.h>

/* Some outputs... */

void error(const char * funcao, const char * erro) {
    printf("%s() => Error : %s\n",funcao,erro);
}

void message(const char * funcao, const char * msg) {
    printf("%s() => %s\n",funcao,msg);
}

void started(const char * funcao) {
    printf("%s() Beginning\n",funcao);
}

void finished(const char * funcao) {
    printf("%s() End\n",funcao);
}

void fatalError(const char * funcao, const char * erro) {
    error(funcao,erro);
    exit(1);
}

/* Some math… */

float min(float a, float b) { return (a <= b) ? a : b; }
float max(float a, float b) { return (a <= b) ? b : a; }

float toRadians(float ang) { return ang * M_PI/180.0f; }

/* Extra */

void progressBar(int current, int max) {
    #define PROGRESS_BAR_STEP 2
    // #define PROGRESS_BAR_STEP 5
    // #define PROGRESS_BAR_STEP 10

    #ifndef _DISABLE_PROGRESS_BAR_
    printf("\r");
    float percent = (current/(float)max) * 100.0f;
    
    printf("[");
    for(unsigned register int i = 0; i < 100; i+=PROGRESS_BAR_STEP) {
        if(i < percent)
            printf("#");
        else printf("_");
    }
    printf("] %3.1f %% ", percent);
    #endif
}
