/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: includes.h
 * Description: Some includes and definitions.
 * =============================================
 */

#ifndef _INCLUDES_
#define _INCLUDES_

/* Define _DEBUG_ for debug messages */
#define _DEBUG_

#include <cstdio>
#include <stdlib.h>
#include <string.h>
#include <cmath>
#include <limits.h>
#include <float.h>
#include <vector>
#include <stdint.h>
#include <time.h>

#include <Video.h>

#define POSITIVE_INFINITY ((FLT_MAX) - 1.0f) 

void error(const char *, const char *);
void message(const char *, const char *);
void started(const char *);
void finished(const char *);
void fatalError(const char *, const char *);

float min(float,float);
float max(float,float);
float toRadians(float ang);

void progressBar(int, int);

#endif
