/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: AbstractObject.cpp
 * Description: AbstractObject methods.
 * =============================================
 */

#include <geometry/Point3D.h>
#include <objects/AbstractObject.h>
#include <objects/Material.h>
#include <animation/Animation.h>

AbstractObject::AbstractObject() {
    animation = NULL;
}

AbstractObject::~AbstractObject() {
    if(material != NULL)
        delete material;
    if(animation != NULL)
        delete animation;
}

void AbstractObject::animate(double currentTimems) {
    if(animation != NULL) {
        if(animation->animate(currentTimems)) {
            position = *(animation->getCurrentPosition());
        }
    }
}
