/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Color.cpp
 * Description: Color methods.
 * =============================================
 */

#include <includes.h>
#include <objects/Color.h>

Color::Color() {
    red = 0.0f;
    green = 0.0f;
    blue = 0.0f;
}

Color::~Color() {

}

Color::Color(float Red, float Green, float Blue) {
    red = Red;
    green = Green;
    blue = Blue;
}

Color Color::multiply(float factor) {
    return Color(red * factor, green * factor, blue * factor);
}

uint32_t Color::toRGB() {
    uint8_t r = min(max(round(red), 0), 255);
    uint8_t g = min(max(round(green), 0), 255);
    uint8_t b = min(max(round(blue), 0), 255);
    return Video::toRGB(r, g, b);
}

float Color::getRed() { return red; }
float Color::getGreen() { return green; }
float Color::getBlue() { return blue; }

void Color::setRed(float Red) { red = Red; }
void Color::setGreen(float Green) { green = Green; }
void Color::setBlue(float Blue) { blue = Blue; }

