/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Color.h
 * Description: Color class definition.
 *     Color represents a color.
 * =============================================
 */

#ifndef _COLOR_
#define _COLOR_

#include <includes.h>

class Color {

    public:
        Color();
        ~Color();
        Color(float Red, float Green, float Blue);
        
        Color multiply(float factor);
        uint32_t toRGB();

        float getRed();
        float getGreen();
        float getBlue();
        
        void setRed(float Red);
        void setGreen(float Green);
        void setBlue(float Blue);

    private:
        float red;
        float green;
        float blue;
};

#endif
