/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Sphere.h
 * Description: Sphere class definition.
 *     Sphere is an AbstractObject.
 * =============================================
 */
#ifdef GAALOP
#ifndef _FRACTAL_
#define _FRACTAL_

#include <engine/Ray.h>
#include <geometry/Point3D.h>
#include <geometry/Vector3D.h>
#include <objects/AbstractObject.h>
#include <objects/Intersection.h>
#ifdef VERSOR
#include <vsr/vsr_cga3D_op.h>
#include <vsr/vsr_cga3D_funcs.h>
#endif

class Fractal : public AbstractObject {

    public:
        Fractal(Point3D Center = Point3D(), float Tolerance = 0.1f);
        ~Fractal();

        Intersection intersect(Ray const& ray);
        Vector3D normal(Point3D intersection);
        void update();

    private:
        float fractal_mv[32];
        float tolerance;
};

#endif
#endif
