#ifndef INTERSECTION_H
#define INTERSECTION_H

#include <objects/AbstractObject.h>
#include <objects/Intersection.h>
#include <geometry/Point3D.h>
#include <objects/Camera.h>
#ifdef VERSOR
#include <vsr/vsr_cga3D_op.h>
#include <vsr/vsr_cga3D_funcs.h>
#endif

#if defined(GAALOP) || defined(VERSOR)
class Intersection {
    public:
        AbstractObject * obj;
        bool valid;
#ifdef GAALOP
        float p[5];
#elif VERSOR
        vsr::cga3D::Point p;
#endif
        float distTo(Camera const& cam) const;
        Intersection() : valid(false) {}
};
#else
class Intersection {
    public:
        AbstractObject * obj;
        float dist;
};
#endif

#endif // INTERSECTION_H
