/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Light.cpp
 * Description: Light methods.
 * =============================================
 */

#include <objects/Light.h>
#include <objects/Color.h>
#include <geometry/Point3D.h>

Light::Light() {
    position = new Point3D(100.0f, 100.0f, 0.0f);
    ambient = new Color(125.0f, 125.0f, 125.0f);
    diffuse = new Color(255.0f, 255.0f, 255.0f);
    specular = new Color(255.0f, 255.0f, 255.0f);
}

Light::~Light() {
    delete position;
    delete ambient;
    delete diffuse;
    delete specular;
}
