/* =============================================
 * Open Core RayTracer
 * Created by Fabio de Albuquerque Dela Antonio
 * fabio914 at gmail.com
 *
 * Based on the RayTracer written by
 * Fernando Vieira Paulovich
 * (http://www.icmc.usp.br/~paulovic)
 * =============================================
 * This code is licensed under the terms of the
 * GNU General Public License (GPL).
 * =============================================
 * File: Light.h
 * Description: Light class definition.
 *     Light represents light position, ambient
 *     color, diffuse color and specular color.
 * =============================================
 */

#ifndef _LIGHT_
#define _LIGHT_

#include <objects/Color.h>
#include <geometry/Point3D.h>

class Light {

    public:
        Light();
        ~Light();

        Point3D * position; //light position
        Color * ambient; //[0,255]
        Color * diffuse; //[0,255]
        Color * specular; //[0,255]

        //float rad = 1; //1 / (a0 + a1 * dist + a2 * dist * dist); //radial attenuation
        //float ang = 1; //angular attenuation
};

#endif